
from string import join
from Acquisition import aq_parent, aq_inner

def getPathOf(object):
    # Mostly copied from Zope/__init__.py .
    orig = object
    if hasattr(object, 'getPhysicalPath'):
        path = join(object.getPhysicalPath(), '/')
    else:
        # Try hard to get the physical path of the object,
        # but there are many circumstances where that's not possible.
        to_append = ()

        if hasattr(object, 'im_self') and hasattr(object, '__name__'):
            # object is a Python method.
            to_append = (object.__name__,)
            object = object.im_self

        while object is not None and \
              not hasattr(object, 'getPhysicalPath'):
            if hasattr(object, 'getId'):
                to_append = (object.getId(),) + to_append
            elif hasattr(object, '__name__'):
                to_append = (object.__name__,) + to_append
            else:
                object = None
                break
            object = aq_parent(aq_inner(object))

        if object is not None:
            path = join(object.getPhysicalPath() + to_append, '/')
        else:
            # Couldn't do it.  Try to just get the id.
            try:
                path = orig.getId()
                if not path:
                    path = repr(orig)
            except:
                path = repr(orig)
    return path
